/* int 16h implementation for DOSRUN
   (C)1999 LGB, Gabor Lenart, lgb@vlug.vein.hu
   GPL software         */

#include "config_dosrun.h"
#ifdef CONFIG_INT16

#include <stdio.h>
#include <unistd.h>
#include "dosrun.h"
#include "options.h"
#include "translate.h"

extern int check_avail_char ( int );

extern word oldcs,oldip;


int int16_emu ( void )
{
  switch (AH) {
    /* read from keyboard */
    case 0x00 : if (config.fullscreen)
								  keyboard_translate_char(getch(),&AL,&AH);
								else
								  read(0,&vm.regs.eax,1);
                return 1;
    /* a BIG fake. We can't read char from stdin without removing it ;-( */
    case 0x01 : if (check_avail_char(0)) CLZ; else STZ;
                return 1;
    /* get keyboard status FAKE!!!!!!!!! */
    case 0x02 : AL=0;
                return 1;
  }
#ifdef CONFIG_DEBUG_UNIMPLEMENTED_FUNC
  if (stddebug) fprintf(stddebug,"INT16: unimplemented function (AX=%04Xh) at %04X:%04X\n",AX,oldcs,oldip);
#endif
  return 1;
}

#endif
