#ifndef _LOCAL_MEMORY_H
#define _LOCAL_MEMORY_H


#define MCB_SIZE 16   /* MCB size in bytes */
#define MCB_PSIZE 1   /* MCB size in paragraphs */
#define SEARCH_BEST    0
#define SEARCH_FIRST   1
#define SEARCH_LAST    2
#define SEARCH_WORST   3
#define SEARCH_MASK    3
#define SEARCH_NOSPLIT 4

#define MCB_X_SIZE(p)   (*(word*)(p+3))
#define MCB_X_OWNER(p)  (*(word*)(p+1))
#define MCB_X_TYPE(p)   (*p)

#define MCB_NEXT(x) (x+MCB_SIZE+(MCB_X_SIZE(x)<<4))

extern byte *dosmem_search   ( int  , int ) ;
extern void  dosmem_init     ( int  , int ) ;
extern void  dosmem_dump     ( void ) ;
extern int   dosmem_alloc    ( int  , int , int ) ;
extern int   dosmem_free     ( int  , int ) ;
extern int   dosmem_realloc  ( int  , int , int );
extern int   dosmem_largest  ( void ) ;
extern void  dosmem_setowner ( int  , int ) ;
extern void  dosmem_romprotect ( void ) ;


#endif
